"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
import pydantic
from pydantic import ConfigDict
from typing import Any, Dict, Union
from typing_extensions import TypeAliasType, TypedDict


AerodromeSlipstreamWithdrawLiquidityProvisionParamsPercentageForWithdrawalTypedDict = TypeAliasType(
    "AerodromeSlipstreamWithdrawLiquidityProvisionParamsPercentageForWithdrawalTypedDict",
    Union[float, str],
)
r"""How much liquidity to take out in percentage."""


AerodromeSlipstreamWithdrawLiquidityProvisionParamsPercentageForWithdrawal = (
    TypeAliasType(
        "AerodromeSlipstreamWithdrawLiquidityProvisionParamsPercentageForWithdrawal",
        Union[float, str],
    )
)
r"""How much liquidity to take out in percentage."""


class AerodromeSlipstreamWithdrawLiquidityProvisionParamsTypedDict(TypedDict):
    r"""Endpoint parameters for liquidity provision withdrawal on aerodrome slipstream.

    This action is performed in a multicall on the NonfungiblePosition Manager: https://github.com/AerodromeSlipstream/v3-periphery/blob/0682387198a24c7cd63566a2c58398533860a5d1/contracts/base/Multicall.sol#L11-L27
    First, we call decrease liquidity then collect the tokens owed to the user.
    """

    token_id: int
    r"""Token ID of the NFT representing the liquidity provisioned position."""
    percentage_for_withdrawal: AerodromeSlipstreamWithdrawLiquidityProvisionParamsPercentageForWithdrawalTypedDict
    r"""How much liquidity to take out in percentage."""


class AerodromeSlipstreamWithdrawLiquidityProvisionParams(BaseModel):
    r"""Endpoint parameters for liquidity provision withdrawal on aerodrome slipstream.

    This action is performed in a multicall on the NonfungiblePosition Manager: https://github.com/AerodromeSlipstream/v3-periphery/blob/0682387198a24c7cd63566a2c58398533860a5d1/contracts/base/Multicall.sol#L11-L27
    First, we call decrease liquidity then collect the tokens owed to the user.
    """

    model_config = ConfigDict(
        populate_by_name=True, arbitrary_types_allowed=True, extra="allow"
    )
    __pydantic_extra__: Dict[str, Any] = pydantic.Field(init=False)

    token_id: int
    r"""Token ID of the NFT representing the liquidity provisioned position."""

    percentage_for_withdrawal: (
        AerodromeSlipstreamWithdrawLiquidityProvisionParamsPercentageForWithdrawal
    )
    r"""How much liquidity to take out in percentage."""

    @property
    def additional_properties(self):
        return self.__pydantic_extra__

    @additional_properties.setter
    def additional_properties(self, value):
        self.__pydantic_extra__ = value  # pyright: ignore[reportIncompatibleVariableOverride]
