"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from compass_api_sdk.types import BaseModel
from compass_api_sdk.utils import validate_const
from enum import Enum
import pydantic
from pydantic import ConfigDict
from pydantic.functional_validators import AfterValidator
from typing import Any, Dict, Literal, Optional, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


class SkySellRequestTokenOut(str, Enum):
    r"""The token you would like to swap 1:1 with USDS. Choose from DAI or USDC."""

    DAI = "DAI"
    USDC = "USDC"


SkySellRequestAmountTypedDict = TypeAliasType(
    "SkySellRequestAmountTypedDict", Union[float, str]
)
r"""The amount of USDS you would like to sell 1:1 for 'token_out'."""


SkySellRequestAmount = TypeAliasType("SkySellRequestAmount", Union[float, str])
r"""The amount of USDS you would like to sell 1:1 for 'token_out'."""


class SkySellRequestTypedDict(TypedDict):
    token_out: SkySellRequestTokenOut
    r"""The token you would like to swap 1:1 with USDS. Choose from DAI or USDC."""
    amount: SkySellRequestAmountTypedDict
    r"""The amount of USDS you would like to sell 1:1 for 'token_out'."""
    sender: str
    r"""The address of the transaction sender."""
    chain: Literal["ethereum:mainnet"]


class SkySellRequest(BaseModel):
    model_config = ConfigDict(
        populate_by_name=True, arbitrary_types_allowed=True, extra="allow"
    )
    __pydantic_extra__: Dict[str, Any] = pydantic.Field(init=False)

    token_out: SkySellRequestTokenOut
    r"""The token you would like to swap 1:1 with USDS. Choose from DAI or USDC."""

    amount: SkySellRequestAmount
    r"""The amount of USDS you would like to sell 1:1 for 'token_out'."""

    sender: str
    r"""The address of the transaction sender."""

    CHAIN: Annotated[
        Annotated[
            Optional[Literal["ethereum:mainnet"]],
            AfterValidator(validate_const("ethereum:mainnet")),
        ],
        pydantic.Field(alias="chain"),
    ] = "ethereum:mainnet"

    @property
    def additional_properties(self):
        return self.__pydantic_extra__

    @additional_properties.setter
    def additional_properties(self, value):
        self.__pydantic_extra__ = value  # pyright: ignore[reportIncompatibleVariableOverride]
